#include<stdio.h>
#include<stdlib.h>
#include<alloca.h>
#include <time.h>

#include "base.h"
#include "field.h"
#include "mvalue.h"
#include "alphabeta.h"

#define AI_ACTION      3
#define MAX_DEPTH     11
#define COUNTER_LEN  100
#define DEGRAD_TIME    5

static int max_depth, counter;
static time_t last_time;

static char ok_move (int depth, mvalue *v)
{
  int i;

  if(depth >= AI_ACTION){
    if(v->attack || v->defense) return 1;
    return 0;
  }
  if(v->a[1] >= 3) return 1;
  for(i=2; i<MVAL_LEN; i++) if(v->a[i]) return 1;
  return 0;
}

static mvalue *cur_vals;

static int squarecmp (const void *s1, const void *s2)
{
  return -val_cmp(&cur_vals[*(int*)s1], &cur_vals[*(int*)s2]);
}

static mvalue alphabeta (int depth, char player, mvalue alpha, mvalue beta, int *bestbranch)
{
  int i, j, s;
  time_t t;
  int mnum;  // pocet prozkoumavanych policek
  mvalue v, nalpha, nbeta;
  mvalue *vals;
  int *squares;
  int branch[MAX_DEPTH+1];
  char defense; // je treba branit?

  counter++;
  if(counter == COUNTER_LEN){  // snizuji hloubku v pripade dlouheho vypoctu
    counter = 0;
    t = time(NULL);
    if(t >= last_time + DEGRAD_TIME){
      last_time = t;
      if(max_depth >= 2) max_depth -= 2;
    }
  }

  bestbranch[depth] = -1;

  // dosla policka nebo hloubka propoctu
  if(depth == max_depth || !freesquares) return val_neut;

  vals = alloca(size * sizeof(mvalue)); // hodnoty policek
  squares = alloca(size * sizeof(int)); // indexy policek

  defense = 0;
  v = val_minf;
  for(i=mnum=0; i < size; i++){
    if(field[i]) continue;  // neprazdne policko

    val_get(i, player, &vals[i]);

    defense |= vals[i].defense;
    if(val_isinf(&vals[i])){   // vyhravam
      bestbranch[depth] = i;
      bestbranch[depth+1] = -1;
      return vals[i];
    }
    if(ok_move(depth, &vals[i])) // vyplati se zkoumat?
      squares[mnum++] = i;

    if(depth == 0) val_randomize(&vals[i]);  // spetka nahody
    if(val_cmp(&vals[i], &v) > 0){  // zatim nejlepsi tah
      if((MAX_DEPTH - depth)%2){
	bestbranch[depth] = i;
	bestbranch[depth+1] = -1;
      }
      v = vals[i];
    }
  }

  if(!mnum || depth > max_depth){     // nic zajimaveho, koncime
    if((MAX_DEPTH - depth)%2) return v;
    else return val_neut;
  }

  if(depth >= AI_ACTION && !defense && val_cmp(&val_neut, &alpha) > 0){
    // nechci vynucovat utok
    bestbranch[depth] = -1;
    alpha = val_neut;
    if(val_cmp(&alpha, &beta) >= 0) return alpha;  // odstihnut betou
  }

  cur_vals = vals; // predavka globalni promenne kvuli qsortu
  qsort(squares, mnum, sizeof(int), squarecmp);

  if(v.a[MVAL_LEN-2] > 0){ // reakce na ctvericku
    if(depth == 0) return v;
    mnum = 1;
  }

  for(i=0; i < mnum; i++){
    s = squares[i];

    field[s] = player;  // hraju na policko
    freesquares--;

    if((MAX_DEPTH - depth) % 2 == 0) val_swapplayers(&vals[s]);

    nalpha = beta;   // negamaxove sarady
    nbeta = alpha;
    val_invert(&nbeta);
    val_invert(&nalpha);
    val_add(&nalpha, &vals[s]);
    val_add(&nbeta, &vals[s]);

    v = alphabeta(depth+1, -player, nalpha, nbeta, branch); // rekurzim se
    val_invert(&v);
    val_add(&v, &vals[s]);

    freesquares++;  // vracim tah
    field[s] = 0;

    if(val_cmp(&v, &alpha) > 0){  // zatim nejlepsi tah
      for(j = depth+1; branch[j] >= 0; j++)
	bestbranch[j] = branch[j];           // zkopiruji vetev
      bestbranch[j] = -1;
      bestbranch[depth] = s;

      alpha = v;
      if(val_cmp(&alpha, &beta) >= 0 || val_isinf(&alpha)) return alpha; // odstihnut betou
    }
  }

  return alpha;
}

int ai_move (char player)
{
  int i;
  int branch[MAX_DEPTH+1];

  counter = 0;

  max_depth = MAX_DEPTH;
  last_time = time(NULL);

  alphabeta(0, player, val_minf, val_pinf, branch);

  return branch[0];

  for(i = 0; branch[i] >= 0; i++){
    if(i%2) field[branch[i]] = -player;
    else field[branch[i]] = player;
    savefield(stdout);
    printf("%d\n", branch[i]);
    printf("\n");
  } 

  return -1;
}
