Ji ohodnocovac funkce (zahraji-li na nejlpe ohodnocen polko)
sama o sob hraje vcelku dobe. Napklad:

\begitems
\item * Pokud me, vyhraje.
\item * Zablokuje tveiku.
\item * Zahraje vidliku.
\item * Zablokuje vidliku.
\item * Vyrob neblokovanou trojiku.
\enditems

Jsou vak situace, kdy je takov tah vyloen patn (hraje za koleko
tam, kde je nakreslena osmika):

\begtt
. . . . . . . . . .
. . . . . . . 8 . .
. . . . . . . . . .
. . . . . . . . . .
. . . . O . . . . .
. . . O X . . . . .
. . X . X . . . . .
. . . . . . . . . .
. . . . . . . . . .
. . . . . . . . . .
. . . . . . . . . .
\endtt

Mm tedy implementovan pemlen dopedu. Zklad je alphabeta
minimax (popsno na Wikipedii). Zanm v hloubce 0, ponouji se do
vych hloubek. Potm v prbhu relativn hodnoty pozic, ale
vsledek je stejn, jako bych v posledn vrstv vdy spotal hodnotu
pslun pozice. Potm to vzhledem k hri, kter hraje v
pedposledn vrstv, snam se, aby, i kdy ukonuji v dvj
vrstv, byla parita vrstvy stejn (na zklad toho vracm nejlep tah
soupee nebo "val_neut"). Navc k tomu mm dal sv heuristick
vylepen:

\label [puntiky]
\begitems

\item * Zkoum jen tahy, co nejsou pehnan daleko od souasnch
      	symbol. Konkrtn hodnota tahu mus  bt vy ne takov, co m na
	pozici 1 hodnotu 3.

\item * Jsem-li za hloubkou 3, zkoumm jen tahy, kde se to nebo
      	brn. Bylo by ovem hloup nutit hre toit, pokud se mu to
      	nevyplat. Proto, pokud hr nemus brnit, dovoluji mu
      	ukonit vtev.

\item * Tahy zkoum v poad od nejlepho, jak mi je ohodnotila
      	"val_get". (Alphabet to pomh.)

\item * V nulov hloubce nhodn trochu upravm hodnoty tah.

\item * Hroz-li mi soupe tveikou, odpovdm rychle a nepotm
      	hodnotu mho tahu.

\item * U programu prohledvajcho do hloubky nemu pedpokldat,
      	e bude pemlet rychle. Proto kadch pt sekund sniuji hloubku
	propotu o 2 (abych se na situaci dval stle stejnm
	hrem). Poten hloubka propotu (definovan jako \dl
      	MAXDEPTH `) je 11, tedy program by neml pemlet dle ne pl minuty.

\enditems

\ifirst {alphabeta.c}{MAX_DEPTH}{}{++}


Funkce \dl [mvalue] alphabeta() vrac negamaxovou hodnotu pro hre
hrajcho za "player", oznut hodnotami "alpha", "beta". Do pole
\dl [int*] bestbranch ulo nejlep posloupnost tah, co vymyslel ukonenou
minus jednikou (tohle by lo optimalizovat, aby vracel jen nejlep
polko v hloubce 0, ale pro ladc ely se to hod).

\ifirst {alphabeta.c}{static mvalue alphabeta}{defense}{++}

Nejprve otestuji, jak na tom jsem s asem. as kontroluji kadch 100
zavoln "alphabeta". Definice \dl COUNTER_LEN udv prv onu stovku,
definice \dl DEGRAD_TIME k, e mm sniovat hloubku kadch 5 sekund.

\ifirst {alphabeta.c}{COUNTER_LEN}{DEGRAD_TIME}{++}

Promnn \dl [int] counter pot sputn "alphabeta", aktuln
maximln hloubka propotu je uloena v promnn \dl [int]
max_depth. Posledn as, kdy jsem zanal nebo snioval hloubku, je
uloen v \dl [time_t] last_time.

\ifirst {alphabeta.c}{max_depth}{counter}{++}

Samotn funkce "alphabeta" pokrauje takto:

\ifirst {alphabeta.c}{counter++}{\empty}{+-}

Dle pro jistotu ukonm "bestbranch".

\inext {}{\empty}{+-}

A otestuji, jestli mi nedola hloubka nebo polka.

\inext {depth}{\empty}{+-}

Pokud ne, tak si alokuji pole "squares" index polek, kam m smysl
hrt a pole "vals" hodnot pslunch tah.

\inext {}{\empty}{+-}

Z dobrch dvod budu indexy polek sypat na zatek pole, zatmco
hodnoty budu umisovat na msta index danch polek. Projdu
vechna polka, poet zajmavch polek mm v promnn "mnum",
nejlpe ohodnocenho polka v promnn "v". V promnn "defense" mm
uloeno, zda jsem nkdy musel brnit.

\inext {}{\space\space\cbrace}{++}

Pitom funkce \dl [char] ok_move(), kter vrac, zda je dan tah
vhodn zkoumat, je definovan takto (podle prvnch dvou puntk na
strnce \pgref[puntiky]):

\ifirst {alphabeta.c}{AI_ACTION}{}{++}

\insf ok_move

Zpt ale k funkci "alphabeta", me bt jet pr dvod, pro funkci
ukonit.

\ifirst {alphabeta.c}{!mnum}{\count=3 \empty}{+-}

Ale pak u musm setdit polka

\inext {}{\empty}{+-}

a jt se rekurzit.

\ifirst {alphabeta.c}{i < mnum}{^^B\space\space\cbrace}{++}

A nakonec jako kad sprvn alphabeta vracm "alpha".

\inext {}{^^B\cbrace}{++}

Pro porovnn polek (abych ml "qsort"u, co pedat) mm funkci \dl
[char] squarecmp.

\dln [mvalue*] curvals
\ifirst {alphabeta.c}{cur_vals}{^^B\cbrace}{++}

Funkci "alphabeta" pro lep komfort obaluje (vol) funkce \dg [int]
ai_move(), kter vrac index tahu, kam chce pota zahrt.

\ifirst {alphabeta.c}{ai_move (}{return}{++}

Zakomentuje-li se tento return, spust se nsledujc kd, kter
zpsob, e pota nezahraje, ale vype, jak si pedstavuje ideln
posloupnost tah (kde oba hri hraj nejlpe).

\inext {}{^^B\cbrace}{++}
