#include<stdio.h>
#include<stdlib.h>
#include <ctype.h>
#include "base.h"
#include "field.h"

int coor2index (int x, int y)
{
  while(x < 0) x += width;
  while(x >= width) x -= width;
  while(y < 0) y += height;
  while(y >= height) y -= height;

  return y*width + x;
}

void index2coor (int index, int *x, int *y)
{
  *x = index%width;
  *y = index/width;
}

char getsquare (int x, int y)
{
  while(x < 0) x += width;
  while(x >= width) x -= width;
  while(y < 0) y += height;
  while(y >= height) y -= height;

  return field[y*width + x];
}

void initfield (int w, int h)
{
  int i;

  width = w;
  height = h;
  size = w*h;
  freesquares = size;
  field = (char *)malloc(size);
  for(i=0; i<size; i++) field[i] = 0;
}

void loadfield (FILE *f)
{
  int ch, i;

  fscanf(f, "%d %d", &height, &width);
  size = width*height;
  field = (char *)malloc(sizeof(char)*size);

  i=0;
  freesquares = 0;
  while(i < size){
    ch = fgetc(f);
    if(isspace(ch)) continue;
    if(ch == 'X' || ch == '#') field[i] = 1;
    else if(ch == 'O' || ch == '8') field[i] = -1;
    else{
      field[i] = 0;
      freesquares++;
    }
    i++;
  }
}

void savefield (FILE *f)
{
  int i;

  fprintf(f, "%d %d", height, width);

  for(i=0; i<size; i++){
    if(i%width == 0) fprintf(f, "\n");

    if(field[i] < 0){
      if(i == lastmove) fprintf(f, "8 ");
      else fprintf(f, "O ");
    }
    else if(field[i] > 0){
      if(i == lastmove) fprintf(f, "# ");
      else fprintf(f, "X ");
    }
    else fprintf(f, ". ");
  }
  fprintf(f, "\n");
}
