#include <gtk/gtk.h>
#include "base.h"
#include "field.h"
#include "statusbar.h"

static char checkrow(int x, int y, int dx, int dy, int *hl)
{
  int i, oindex;

  for(i=0; i<WINLEN && getsquare(x, y) == cur_player; i++){
    x -= dx;
    y -= dy;
  }
  x += dx;
  y += dy;

  oindex = coor2index(x, y);
  field[oindex] = 0;

  x += dx;
  y += dy;

  for(i=1; i<WINLEN && getsquare(x, y) == cur_player; i++){
    x += dx;
    y += dy;
  }

  field[oindex] = cur_player;

  if(i < WINLEN) return 0;

  x -= dx;
  y -= dy;

  for(i=0; i<WINLEN; i++){
    hl[i] = coor2index(x, y);
    x -= dx;
    y -= dy;
  }
  hl[i] = -1;

  return 1;
}

void move(int index, int *hl)
{
  int x, y;

  field[index] = cur_player;
  freesquares--;

  index2coor(index, &x, &y);
  if(checkrow(x, y, 0, 1, hl) || checkrow(x, y, 1, 0, hl) ||
     checkrow(x, y, 1, 1, hl) || checkrow(x, y, -1, 1, hl)){
    set_finished(cur_player);
    return;
  }

  if(!freesquares){
    set_finished(0);
    hl[0] = -1;
  }
  else{
    change_player();
    hl[0] = index;
    hl[1] = -1;
  }
}
