#include <gtk/gtk.h>
#include "field.h"
#include "statusbar.h"
#include "table.h"
#include "spawn.h"

#define MAX_W 100
#define MAX_H 100

static GtkDialog *dialog;
static GtkSpinButton *w_spin, *h_spin;
static GtkToggleButton *aip_check[2], *Xstart_check;

void function_ok(GtkWidget *widget, gpointer data)
{
  int i;
  int w, h, p;
  char aip[2];

  w = (int)gtk_spin_button_get_value(w_spin);
  h = (int)gtk_spin_button_get_value(h_spin);
  if(gtk_toggle_button_get_active(Xstart_check)) p = 1;
  else p = -1;

  for(i=0; i<2; i++){
    if(gtk_toggle_button_get_active(aip_check[i])) aip[i] = 1;
    else aip[i] = 0;
  }

  gtk_widget_destroy(GTK_WIDGET(dialog));

  table_reset(w, h);
  start(p, aip[0], aip[1]);
}

void function_cancel(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(dialog));
}

void ngame_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *label, *button, *hbox;
  char str[20];
  int i;

  dialog = GTK_DIALOG(gtk_dialog_new());
  gtk_window_set_title (GTK_WINDOW (dialog), "Nova hra");

  // Width

  label = gtk_label_new ("Sirka");
  w_spin = GTK_SPIN_BUTTON(gtk_spin_button_new_with_range (1, MAX_W, 1));
  gtk_spin_button_set_value(w_spin, width);
  hbox = gtk_hbox_new(1, 0);

  gtk_container_add(GTK_CONTAINER(hbox), label);
  gtk_container_add(GTK_CONTAINER(hbox), GTK_WIDGET(w_spin));

  gtk_container_add(GTK_CONTAINER (dialog->vbox), hbox);

  // Height

  label = gtk_label_new ("Vyska");
  h_spin = GTK_SPIN_BUTTON(gtk_spin_button_new_with_range (1, MAX_H, 1));
  gtk_spin_button_set_value(h_spin, height);
  hbox = gtk_hbox_new(1, 0);

  gtk_container_add(GTK_CONTAINER(hbox), label);
  gtk_container_add(GTK_CONTAINER(hbox), GTK_WIDGET(h_spin));

  gtk_container_add(GTK_CONTAINER (dialog->vbox), hbox);

  // AI

  for(i=0; i<2; i++){
    sprintf(str, "pocitac za %s", player_name[i]);
    aip_check[i] = GTK_TOGGLE_BUTTON(gtk_check_button_new_with_label(str));

    gtk_container_add(GTK_CONTAINER (dialog->vbox),
		      GTK_WIDGET(aip_check[i]));
    gtk_toggle_button_set_active(aip_check[i], ai_player[i]);
  }

  sprintf(str, "zacina %s", player_name[1]);
  Xstart_check = GTK_TOGGLE_BUTTON(gtk_check_button_new_with_label(str));

  gtk_container_add(GTK_CONTAINER (dialog->vbox),
		    GTK_WIDGET(Xstart_check));
  gtk_toggle_button_set_active(Xstart_check, (start_player+1)/2);

  button = gtk_button_new_with_label ("Cancel");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_box_pack_start (GTK_BOX (dialog->action_area),
		      button, TRUE, TRUE, 0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (function_cancel), NULL);

  button = gtk_button_new_with_label ("OK");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_box_pack_start (GTK_BOX (dialog->action_area),
		      button, TRUE, TRUE, 0);
  gtk_widget_grab_default (button);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (function_ok), NULL);

  gtk_widget_show_all (GTK_WIDGET(dialog));
  gtk_grab_add (GTK_WIDGET(dialog));
}
