#include<stdio.h>
#include<string.h>

#include "base.h"
#include "alphabeta.h"
#include "field.h"
#include "mvalue.h"

int main (int argc, char **argv)
{
  FILE *f;
  char *filename;
  char player;
  int i;

  player = 1;
  filename = NULL;

  for(i=1; i < argc; i++){
    if(argc >= 2 && !strcmp(argv[i], "-O") && player == 1) player = -1;
    else if(i == argc-1) filename = argv[i];
    else{
      fprintf(stderr, "Usage: piskvorky_ai [-O] [filename]\n");
      return 1;
    }
  }

  if(filename){
    if(!(f = fopen(filename, "r"))){
      fprintf(stderr, "Reading file '%s' failed.\n", filename);
      return 1;
    }
  }
  else f = stdin;

  loadfield(f);
  fclose(f);

  val_init();

  lastmove = ai_move(player);

  if(lastmove >= 0 && lastmove < size){
    if(filename){
      field[lastmove] = player;
      if(!(f = fopen("hra", "w"))){
	fprintf(stderr, "Writing file '%s' failed.\n", filename);
	return 1;
      }
      savefield(f);
      fclose(f);
    }
    else printf("%d\n", lastmove);
  }

  return 0;
}
