#include <gtk/gtk.h>
#include "field.h"
#include "statusbar.h"
#include "spawn.h"

const char *player_name[2] = {"kolecko", "krizek"};
static GtkWidget *statusbar;
static int context_id;

static void set_status(char *str)
{
  gtk_statusbar_pop(GTK_STATUSBAR(statusbar), context_id);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar), context_id, str);
}

void start(int player, char ai0, char ai1)
{
  ai_playing = 0;
  ai_kill();
  finished = 0;

  ai_player[0] = ai0;
  ai_player[1] = ai1;
  start_player = player;
  cur_player = -player;
  change_player();
}

void create_statusbar(GtkWidget *vbox)
{
  statusbar = gtk_statusbar_new();
  gtk_box_pack_end (GTK_BOX(vbox), statusbar, 0, 0, 0);
  gtk_widget_show(statusbar);

  context_id = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "neco");
}

void change_player()
{
  char str[30];

  cur_player = -cur_player;
  ai_playing = ai_player[(cur_player+1)/2];

  if(ai_playing){
    sprintf(str, "Premyslim za %s.", player_name[(cur_player+1)/2]);
    ai_play();
  }
  else sprintf(str, "Hrajes za %s.", player_name[(cur_player+1)/2]);

  set_status(str);
}

void set_finished(char player)
{
  char str[50];

  finished = 1;

  if(player){
    if(player == 2 || player == -2)
      sprintf(str, "Aj, chyba! Neumim premyslet za %s. :(",
	      player_name[(player/2+1)/2]);
    else sprintf(str, "Vitezi %s.", player_name[(player+1)/2]);

    set_status(str);
  }
  else set_status("Hra skoncila remizou.");
}
